#version 460 core

in vec2 UV;
in vec4 fragmentColor;

uniform sampler2D sampler;

out vec4 color;

void main()
{
    vec4 col = texture(sampler, UV) * fragmentColor;
    //vec4 col = fragmentColor;
    //if (all(lessThan(col, vec4(0.1, 0.1, 0.1, 1.0))))
    //    discard;
    
    // Filtering of near-black particles (optimisation of additive mixing effects)
    if (col.r < 0.1 && col.g < 0.1 && col.b < 0.1 || col.a < 0.1)
        discard;

    color = vec4(col.rgb * 1.5, col.a); // Brighten particles
    // color = vec4(col.rgb);
    // color = vec4(1.0, 0.8, 0.2, 1.0); // Test for bright yellow particles

}